ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/App-Staticperl/staticperl.sh
(Generate patch)

Comparing App-Staticperl/staticperl.sh (file contents):
Revision 1.16 by root, Sat Dec 11 15:51:38 2010 UTC vs.
Revision 1.75 by root, Tue Aug 1 03:48:59 2023 UTC

1#!/bin/sh 1#!/bin/sh
2 2
3############################################################################# 3#############################################################################
4# configuration to fill in 4# configuration to fill in (or to replace in your .staticperlrc)
5 5
6STATICPERL=~/.staticperl 6STATICPERL=~/.staticperl
7CPAN=http://mirror.netcologne.de/cpan # which mirror to use 7CPAN=http://mirror.netcologne.de/cpan # which mirror to use
8EMAIL="read the documentation <rtfm@example.org>" 8EMAIL="read the documentation <rtfm@example.org>"
9DLCACHE=
9 10
10# perl build variables 11# perl build variables
11PERL_VERSION=5.12.2 # 5.8.9 is also a good choice 12MAKE=make
13PERL_VERSION=http://stableperl.schmorp.de/dist/latest.tar.gz # 5.12.5 and 5.8.9 are good choices for small builds
14PERL_CC=cc
12PERL_CONFIGURE="" # additional Configure arguments 15PERL_CONFIGURE="" # additional Configure arguments
13PERL_CPPFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=65536 -D_GNU_SOURCE -DNDEBUG -USITELIB_EXP -USITEARCHEXP -UARCHLIB_EXP" 16PERL_CCFLAGS="-g -DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=16376 -DNO_PERL_MALLOC_ENV -D_GNU_SOURCE -DNDEBUG"
14PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math" 17PERL_OPTIMIZE="-Os" # -Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math"
15 18
16ARCH="$(uname -m)" 19ARCH="$(uname -m)"
17 20
18case "$ARCH" in 21#case "$ARCH" in
19 i*86 | x86_64 | amd64 ) 22# i*86 | x86_64 | amd64 )
20 PERL_OPTIMIZE="$PERL_OPTIMIZE -mpush-args -mno-inline-stringops-dynamically -mno-align-stringops -mno-ieee-fp" # x86/amd64 23# PERL_OPTIMIZE="$PERL_OPTIMIZE -mpush-args -mno-inline-stringops-dynamically -mno-align-stringops -mno-ieee-fp" # x86/amd64
21 case "$ARCH" in 24# case "$ARCH" in
22 i*86 ) 25# i*86 )
23 PERL_OPTIMIZE="$PERL_OPTIMIZE -fomit-frame-pointer -march=pentium3 -mtune=i386" # x86 only 26# PERL_OPTIMIZE="$PERL_OPTIMIZE -fomit-frame-pointer -march=pentium3 -mtune=i386" # x86 only
24 ;; 27# ;;
25 esac 28# esac
26 ;; 29# ;;
27esac 30#esac
28 31
29# -Wl,--gc-sections makes it impossible to check for undefined references 32# -Wl,--gc-sections makes it impossible to check for undefined references
30# for some reason so we need to patch away the "-no" after Configure and before make :/ 33# for some reason so we need to patch away the "-no" after Configure and before make :/
31# --allow-multiple-definition exists to work around uclibc's pthread static linking bug 34# --allow-multiple-definition exists to work around uclibc's pthread static linking bug
32PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition" 35#PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition"
36PERL_LDFLAGS=
33PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself 37PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself
34 38
35# some configuration options for modules 39# some configuration options for modules
36export PERL_MM_USE_DEFAULT=1 40PERL_MM_USE_DEFAULT=1
41PERL_MM_OPT="MAN1PODS= MAN3PODS="
37#export CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow 42#CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow
38export EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0' 43#EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0'
44export PERL_MM_USE_DEFAULT PERL_MM_OPT
39 45
40# which extra modules to install by default from CPAN that are 46# which extra modules to install by default from CPAN that are
41# required by mkbundle 47# required by mkbundle
42STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage" 48STATICPERL_MODULES="ExtUtils::MakeMaker ExtUtils::CBuilder common::sense Pod::Strip PPI PPI::XS Pod::Usage"
43 49
44# which extra modules you might want to install 50# which extra modules you might want to install
45EXTRA_MODULES="" 51EXTRA_MODULES=""
46 52
47# overridable functions 53# overridable functions
48preconfigure() { : ; } 54preconfigure() { : ; }
55patchconfig() { : ; }
49postconfigure() { : ; } 56postconfigure() { : ; }
50postbuild() { : ; } 57postbuild() { : ; }
58postcpanconfig() { : ; }
51postinstall() { : ; } 59postinstall() { : ; }
52 60
53# now source user config, if any 61# now source user config, if any
54if [ "$STATICPERLRC" ]; then 62if [ "$STATICPERLRC" ]; then
55 . "$STATICPERLRC" 63 . "$STATICPERLRC"
56else 64else
60fi 68fi
61 69
62############################################################################# 70#############################################################################
63# support 71# support
64 72
65MKBUNDLE="${MKBUNDLE:=$STATICPERL/mkbundle}" 73# work around ExtUtils::CBuilder and others
74export CC="$PERL_CC"
75export CFLAGS="$PERL_CFLAGS"
76export LD="$PERL_CC"
77export LDFLAGS="$PERL_LDFLAGS"
78unset LIBS
79
66PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed 80PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed
67 81
68unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG 82unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG
83unset PERL_MB_OPT
69export LC_ALL=C # just to be on the safe side 84LC_ALL=C; export LC_ALL # just to be on the safe side
85
86# prepend PATH - not required by staticperl itself, but might make
87# life easier when working in e.g. "staticperl cpan / look"
88PATH="$PERL_PREFIX/perl/bin:$PATH"
70 89
71# set version in a way that Makefile.PL can extract 90# set version in a way that Makefile.PL can extract
72VERSION=VERSION; eval \ 91VERSION=VERSION; eval \
73$VERSION=0.911 92$VERSION="1.46"
74
75BZ2=bz2
76BZIP2=bzip2
77 93
78fatal() { 94fatal() {
79 printf -- "\nFATAL: %s\n\n" "$*" >&2 95 printf -- "\nFATAL: %s\n\n" "$*" >&2
80 exit 1 96 exit 1
81} 97}
121 137
122############################################################################# 138#############################################################################
123# download/configure/compile/install perl 139# download/configure/compile/install perl
124 140
125clean() { 141clean() {
126 rm -rf "$STATICPERL/src/perl-$PERL_VERSION" 142 rm -rf "$STATICPERL/src"
143}
144
145realclean() {
146 rm -f "$PERL_PREFIX/staticstamp.postinstall"
147 rm -f "$PERL_PREFIX/staticstamp.install"
148 rm -f "$STATICPERL/src/perl/staticstamp.configure"
127} 149}
128 150
129fetch() { 151fetch() {
152(
130 rcd "$STATICPERL" 153 rcd "$STATICPERL"
131 154
132 mkdir -p src 155 mkdir -p src
133 rcd src 156 rcd src
134 157
135 if ! [ -d "perl-$PERL_VERSION" ]; then 158 if ! [ -d "perl" ]; then
136 if ! [ -e "perl-$PERL_VERSION.tar.$BZ2" ]; then 159 rm -rf unpack
160 mkdir -p unpack
137 161
162 case "$PERL_VERSION" in
163 *:* )
164 # url
165 PERLURL="$PERL_VERSION"
166 PERLTAR="$(basename "$PERL_VERSION")"
167 ;;
168 /* )
169 # directory
170 verbose "copying $PERL_VERSION"
171 cp -Rp "$PERL_VERSION/." unpack/.
172 chmod -R u+w unpack
173 mv unpack perl
174 return
175 ;;
176 * )
138 URL="$CPAN/src/5.0/perl-$PERL_VERSION.tar.$BZ2" 177 PERLURL="$CPAN/src/5.0/perl-$PERL_VERSION.tar.bz2"
178 PERLTAR=perl-$PERL_VERSION.tar.bz2
179 ;;
180 esac
139 181
182 if ! [ -e "$PERLTAR" ]; then
140 verblock <<EOF 183 verblock <<EOF
141downloading perl 184downloading perl
185
186trying to download from $PERLURL
187
188you can configure a download cache directory via DLCACHE
189in your .staticperlrc to avoid repeated downloads.
190
142to manually download perl yourself, place 191to manually download perl yourself, place a suitable tarball in
143perl-$PERL_VERSION.tar.$BZ2 in $STATICPERL 192$DLCACHE/$PERLTAR
144trying $URL
145EOF
146 193
194either curl or wget is required for automatic download.
195curl is tried first, then wget.
196EOF
197
147 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side 198 rm -f $PERLTAR~ # just to be on the safe side
148 wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \ 199 { [ "$DLCACHE" ] && cp "$DLCACHE"/$PERLTAR $PERLTAR~ >/dev/null 2>&1; } \
149 || curl >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \ 200 || wget -O $PERLTAR~ "$PERLURL" \
201 || curl -f >$PERLTAR~ "$PERLURL" \
150 || fatal "$URL: unable to download" 202 || fatal "$URL: unable to download"
151 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2 203 rm -f $PERLTAR
204 mv $PERLTAR~ $PERLTAR
205 if [ "$DLCACHE" ]; then
206 mkdir -p "$DLCACHE"
207 cp $PERLTAR "$DLCACHE"/$PERLTAR~$$~ && \
208 mv "$DLCACHE"/$PERLTAR~$$~ "$DLCACHE"/$PERLTAR
209 fi
152 fi 210 fi
153 211
154 verblock <<EOF 212 verblock <<EOF
155unpacking perl 213unpacking perl
156EOF 214EOF
157 215
158 mkdir -p unpack 216 case "$PERLTAR" in
159 $BZIP2 -d <perl-$PERL_VERSION.tar.bz2 | tar xfC - unpack \ 217 *.xz ) UNCOMPRESS="xz -d" ;;
218 *.lzma ) UNCOMPRESS="lzma -d" ;;
219 *.bz2 ) UNCOMPRESS="bzip2 -d" ;;
220 *.gz ) UNCOMPRESS="gzip -d" ;;
221 *.tar ) UNCOMPRESS="cat" ;;
222 * )
223 fatal "don't know hot to uncompress $PERLTAR,\nonly tar, tar.gz, tar.bz2, tar.lzma and tar.xz are supported."
224 exit 1
225 ;;
226 esac
227
228 <"$PERLTAR" $UNCOMPRESS -d | ( cd unpack && tar xf - ) \
160 || fatal "perl-$PERL_VERSION.tar.bz2: error during unpacking" 229 || fatal "$PERLTAR: error during unpacking"
161 chmod -R u+w unpack/perl-$PERL_VERSION 230
162 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION 231 if [ -d unpack/*/ ]; then
232 chmod -R u+w unpack/*/
233 mv unpack/*/ perl
163 rmdir -p unpack 234 rmdir -p unpack
235 else
236 fatal "unpacking $PERLTAR did not result in a single directory, don't know how to handle this"
237 fi
238
239 rm "$PERLTAR"
164 fi 240 fi
241) || exit
165} 242}
166 243
167# similar to GNU-sed -i or perl -pi 244# similar to GNU-sed -i or perl -pi
168sedreplace() { 245sedreplace() {
169 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed" 246 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed"
247 rm -f "$2"
170 mv "$2~" "$2" 248 mv "$2~" "$2"
171} 249}
172 250
251configure_failure() {
252 cat <<EOF
253
254
255***
256*** Configure failed - see above for the exact error message(s).
257***
258*** Most commonly, this is because the default PERL_CCFLAGS or PERL_OPTIMIZE
259*** flags are not supported by your compiler. Less often, this is because
260*** PERL_LIBS either contains a library not available on your system (such as
261*** -lcrypt), or because it lacks a required library (e.g. -lsocket or -lnsl).
262***
263*** You can provide your own flags by creating a ~/.staticperlrc file with
264*** variable assignments. For example (these are the actual values used):
265***
266
267PERL_CC="$PERL_CC"
268PERL_CCFLAGS="$PERL_CCFLAGS"
269PERL_OPTIMIZE="$PERL_OPTIMIZE"
270PERL_LDFLAGS="$PERL_LDFLAGS"
271PERL_LIBS="$PERL_LIBS"
272
273EOF
274 exit 1
275}
276
173configure() { 277configure() {
278(
174 fetch 279 fetch
175 280
176 rcd "$STATICPERL/src/perl-$PERL_VERSION" 281 rcd "$STATICPERL/src/perl"
177 282
178 [ -e staticstamp.configure ] && return 283 [ -e staticstamp.configure ] && return
179 284
180 verblock <<EOF 285 verblock <<EOF
181configuring $STATICPERL/src/perl-$PERL_VERSION 286configuring $STATICPERL/src/perl
182EOF 287EOF
183 288
184 rm -f "$PERL_PREFIX/staticstamp.install" 289 rm -f "$PERL_PREFIX/staticstamp.install"
185 290
186 make distclean >/dev/null 2>&1 291 "$MAKE" distclean >/dev/null 2>&1
187 292
293 sedreplace '/^#define SITELIB/d' config_h.SH
294
188 # I hate them 295 # I hate them for this
189 grep -q -- -fstack-protector Configure && \ 296 grep -q -- -fstack-protector Configure && \
190 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure 297 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure
191 298
192 preconfigure 299 # what did that bloke think
300 grep -q -- usedl=.define hints/darwin.sh && \
301 sedreplace '/^usedl=.define.;$/d' hints/darwin.sh
302
303 preconfigure || fatal "preconfigure hook failed"
193 304
194# trace configure \ 305# trace configure \
195 sh Configure -Duselargefiles \ 306 sh Configure -Duselargefiles \
196 -Uuse64bitint \ 307 -Uuse64bitint \
197 -Dusemymalloc=n \ 308 -Dusemymalloc=n \
198 -Uusedl \ 309 -Uusedl \
199 -Uusethreads \ 310 -Uusethreads \
200 -Uuseithreads \ 311 -Uuseithreads \
201 -Uusemultiplicity \ 312 -Uusemultiplicity \
202 -Duseperlio \
203 -Uusesfio \ 313 -Uusesfio \
204 -Uuseshrplib \ 314 -Uuseshrplib \
315 -Uinstallusrbinperl \
205 -Dcppflags="$PERL_CPPFLAGS" \ 316 -A ccflags=" $PERL_CCFLAGS" \
206 -Dccflags="-g2 -fno-strict-aliasing" \ 317 -Dcc="$PERL_CC" \
207 -Doptimize="$PERL_OPTIMIZE" \ 318 -Doptimize="$PERL_OPTIMIZE" \
208 -Dldflags="$PERL_LDFLAGS" \ 319 -Dldflags="$PERL_LDFLAGS" \
209 -Dlibs="$PERL_LIBS" \ 320 -Dlibs="$PERL_LIBS" \
210 -Dprefix="$PERL_PREFIX" \ 321 -Dprefix="$PERL_PREFIX" \
211 -Dbin="$PERL_PREFIX/bin" \ 322 -Dbin="$PERL_PREFIX/bin" \
212 -Dprivlib="$PERL_PREFIX/lib" \ 323 -Dprivlib="$PERL_PREFIX/lib" \
213 -Darchlib="$PERL_PREFIX/lib" \ 324 -Darchlib="$PERL_PREFIX/lib" \
214 -Uusevendorprefix \ 325 -Uusevendorprefix \
215 -Dsitelib="$PERL_PREFIX/lib" \ 326 -Dsitelib="$PERL_PREFIX/lib" \
216 -Dsitearch="$PERL_PREFIX/lib" \ 327 -Dsitearch="$PERL_PREFIX/lib" \
217 -Usitelibexp \
218 -Uman1dir \ 328 -Uman1dir \
219 -Uman3dir \ 329 -Uman3dir \
220 -Usiteman1dir \ 330 -Usiteman1dir \
221 -Usiteman3dir \ 331 -Usiteman3dir \
222 -Dpager=/usr/bin/less \ 332 -Dpager=/usr/bin/less \
223 -Demail="$EMAIL" \ 333 -Demail="$EMAIL" \
224 -Dcf_email="$EMAIL" \ 334 -Dcf_email="$EMAIL" \
225 -Dcf_by="$EMAIL" \ 335 -Dcf_by="$EMAIL" \
226 $PERL_CONFIGURE \ 336 $PERL_CONFIGURE \
337 -Duseperlio \
338 -Uversiononly \
227 -dE || fatal "Configure failed" 339 -dE || configure_failure
228 340
229 sedreplace ' 341 sedreplace '
230 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g 342 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g
231 s/ *-fno-stack-protector */ /g 343 s/ *-fno-stack-protector */ /g
232 ' config.sh 344 ' config.sh
233 345
346 patchconfig || fatal "patchconfig hook failed"
347
234 sh Configure -S || fatal "Configure -S failed" 348 sh Configure -S || fatal "Configure -S failed"
235 349
236 postconfigure || fatal "postconfigure hook failed" 350 postconfigure || fatal "postconfigure hook failed"
237 351
238 touch staticstamp.configure 352 : > staticstamp.configure
353) || exit
354}
355
356write_shellscript() {
357 {
358 echo "#!/bin/sh"
359 echo "STATICPERL=\"$STATICPERL\""
360 echo "PERL_PREFIX=\"$PERL_PREFIX\""
361 echo "MAKE=\"$MAKE\""
362 cat
363 } >"$PERL_PREFIX/bin/$1"
364 chmod 755 "$PERL_PREFIX/bin/$1"
239} 365}
240 366
241build() { 367build() {
368(
242 configure 369 configure
243 370
244 rcd "$STATICPERL/src/perl-$PERL_VERSION" 371 rcd "$STATICPERL/src/perl"
245 372
246 verblock <<EOF 373 verblock <<EOF
247building $STATICPERL/src/perl-$PERL_VERSION 374building $STATICPERL/src/perl
248EOF 375EOF
249 376
250 rm -f "$PERL_PREFIX/staticstamp.install" 377 rm -f "$PERL_PREFIX/staticstamp.install"
251 378
252 make || fatal "make: error while building perl" 379 "$MAKE" || fatal "make: error while building perl"
253 380
254 postbuild || fatal "postbuild hook failed" 381 postbuild || fatal "postbuild hook failed"
382) || exit
383}
384
385_postinstall() {
386 if ! [ -e "$PERL_PREFIX/staticstamp.postinstall" ]; then
387 NOCHECK_INSTALL=+
388 instcpan $STATICPERL_MODULES
389 [ "$EXTRA_MODULES" ] && instcpan $EXTRA_MODULES
390
391 postinstall || fatal "postinstall hook failed"
392
393 : > "$PERL_PREFIX/staticstamp.postinstall"
394 fi
255} 395}
256 396
257install() { 397install() {
398(
258 if ! [ -e "$PERL_PREFIX/staticstamp.install" ]; then 399 if ! [ -e "$PERL_PREFIX/staticstamp.install" ]; then
259 build 400 build
260 401
261 verblock <<EOF 402 verblock <<EOF
262installing $STATICPERL/src/perl-$PERL_VERSION 403installing $STATICPERL/src/perl
263to $PERL_PREFIX 404to $PERL_PREFIX
264EOF 405EOF
265 406
266 ln -sf "perl/bin/" "$STATICPERL/bin" 407 ln -sf "perl/bin/" "$STATICPERL/bin"
267 ln -sf "perl/lib/" "$STATICPERL/lib" 408 ln -sf "perl/lib/" "$STATICPERL/lib"
268 409
410 mkdir "$STATICPERL/patched"
411
269 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten 412 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten
270 rm -rf "$PERL_PREFIX" # by this rm -rf 413 rm -rf "$PERL_PREFIX" # by this rm -rf
271 414
415 rcd "$STATICPERL/src/perl"
416
272 make install || fatal "make install: error while installing" 417 "$MAKE" install || fatal "make install: error while installing"
273 418
274 rcd "$PERL_PREFIX" 419 rcd "$PERL_PREFIX"
275 420
276 # create a "make install" replacement for CPAN 421 # create a "make install" replacement for CPAN
277 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF 422 write_shellscript SP-make-make <<'end_of_make'
278make || exit 423#CAT make-make.sh
424end_of_make
279 425
280if find blib/arch/auto -type f | grep -q -v .exists; then 426 # create a "make install" replacement for CPAN
281 echo Probably an XS module, rebuilding perl 427 write_shellscript SP-make-install-make <<'end_of_make_install_make'
282 if make perl; then 428#CAT make-install-make.sh
283 mv perl "$PERL_PREFIX"/bin/perl 429end_of_make_install_make
284 make -f Makefile.aperl map_clean
285 else
286 make -f Makefile.aperl map_clean
287 exit 1
288 fi
289fi
290 430
291make install UNINST=1 431 # create a "patch modules" helper
292EOF 432 write_shellscript SP-patch-postinstall <<'end_of_patch_postinstall'
293 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install 433#CAT patch-postinstall.sh
434end_of_patch_postinstall
294 435
436 # immediately use it
437 "$PERL_PREFIX/bin/SP-patch-postinstall"
438
295 # trick CPAN into avoiding ~/.cpan completely 439 # help to trick CPAN into avoiding ~/.cpan completely
296 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm" 440 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm"
297 441
442 # we call cpan with -MCPAN::MyConfig in this script, which
443 # is strictly unnecessary as we have to patch CPAN anyway,
444 # so consider it "for good measure".
298 "$PERL_PREFIX"/bin/perl -MCPAN -e ' 445 "$PERL_PREFIX"/bin/perl -MCPAN::MyConfig -MCPAN -e '
299 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'"); 446 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'");
447 CPAN::Shell->o (conf => pushy_https => "0");
300 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 448 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
301 CPAN::Shell->o (conf => q<init>); 449 CPAN::Shell->o (conf => q<init>);
302 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 450 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
303 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build"); 451 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build");
304 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs"); 452 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs");
305 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile"); 453 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile");
306 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources"); 454 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources");
455 CPAN::Shell->o (conf => q<makepl_arg>, "MAP_TARGET=perl");
456 CPAN::Shell->o (conf => q<make>, "'"$PERL_PREFIX"'/bin/SP-make-make");
307 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/cpan-make-install"); 457 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/SP-make-install-make");
308 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>); 458 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>);
309 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>); 459 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<yes>);
460 CPAN::Shell->o (conf => q<recommends_policy>, q<0>);
461 CPAN::Shell->o (conf => q<suggests_policy>, q<0>);
462 CPAN::Shell->o (conf => q<prefer_installer>, q<EUMM>);
310 CPAN::Shell->o (conf => q<commit>); 463 CPAN::Shell->o (conf => q<commit>);
311 ' || fatal "error while initialising CPAN" 464 ' || fatal "error while initialising CPAN"
312 465
466 postcpanconfig
467
313 touch "$PERL_PREFIX/staticstamp.install" 468 : > "$PERL_PREFIX/staticstamp.install"
314 fi 469 fi
315 470
471 _postinstall
472) || exit
473}
474
475import() {
476(
477 IMPORT="$1"
478
479 rcd "$STATICPERL"
480
316 if ! [ -e "$PERL_PREFIX/staticstamp.postinstall" ]; then 481 if ! [ -e "$PERL_PREFIX/staticstamp.install" ]; then
317 NOCHECK_INSTALL=+ 482 verblock <<EOF
318 instcpan $STATICPERL_MODULES 483import perl from $IMPORT to $STATICPERL
319 [ $EXTRA_MODULES ] && instcpan $EXTRA_MODULES 484EOF
320 485
321 postinstall || fatal "postinstall hook failed" 486 rm -rf bin cpan lib patched perl src
487 mkdir -m 755 perl perl/bin
488 ln -s perl/bin/ bin
489 ln -s "$IMPORT" perl/bin/
322 490
491 echo "$IMPORT" > "$PERL_PREFIX/.import"
492
323 touch "$PERL_PREFIX/staticstamp.postinstall" 493 : > "$PERL_PREFIX/staticstamp.install"
324 fi 494 fi
495
496 _postinstall
497) || exit
325} 498}
326 499
327############################################################################# 500#############################################################################
328# install a module from CPAN 501# install a module from CPAN
329 502
330instcpan() { 503instcpan() {
331 [ $NOCHECK_INSTALL ] || install 504 [ $NOCHECK_INSTALL ] || install
332 505
333 verblock <<EOF 506 verblock <<EOF
334installing modules from CPAN 507installing modules from CPAN
335$@ 508$*
336EOF 509EOF
337 510
338 for mod in "$@"; do 511 MYCONFIG=
339 "$PERL_PREFIX"/bin/perl -MCPAN -e 'notest install => "'"$mod"'"' \ 512 [ -e "$PERL_PREFIX/.import" ] || MYCONFIG=-MCPAN::MyConfig
340 || fatal "$mod: unable to install from CPAN" 513
341 done 514 "$PERL_PREFIX"/bin/perl $MYCONFIG -MCPAN -e 'notest (install => $_) for @ARGV' -- "$@" | tee "$STATICPERL/instcpan.log"
515
516 if grep -q " -- NOT OK\$" "$STATICPERL/instcpan.log"; then
517 fatal "failure while installing modules from CPAN ($*)"
518 fi
342 rm -rf "$STATICPERL/build" 519 rm -f "$STATICPERL/instcpan.log"
343} 520}
344 521
345############################################################################# 522#############################################################################
346# install a module from unpacked sources 523# install a module from unpacked sources
347 524
348instsrc() { 525instsrc() {
349 [ $NOCHECK_INSTALL ] || install 526 [ $NOCHECK_INSTALL ] || install
350 527
351 verblock <<EOF 528 verblock <<EOF
352installing modules from source 529installing modules from source
353$@ 530$*
354EOF 531EOF
355 532
356 for mod in "$@"; do 533 for mod in "$@"; do
357 echo 534 echo
358 echo $mod 535 echo $mod
359 ( 536 (
360 rcd $mod 537 rcd $mod
361 make -f Makefile.aperl map_clean >/dev/null 2>&1 538 "$MAKE" -f Makefile.aperl map_clean >/dev/null 2>&1
362 make distclean >/dev/null 2>&1 539 "$MAKE" distclean >/dev/null 2>&1
363 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL" 540 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL"
364 make || fatal "$mod: error building module" 541 "$MAKE" || fatal "$mod: error building module"
365 "$PERL_PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module" 542 "$PERL_PREFIX"/bin/SP-make-install-make install || fatal "$mod: error installing module"
366 make distclean >/dev/null 2>&1 543 "$MAKE" distclean >/dev/null 2>&1
367 exit 0 544 exit 0
368 ) || exit $? 545 ) || exit $?
369 done 546 done
370} 547}
371 548
372############################################################################# 549#############################################################################
373# main 550# main
374 551
375podusage() { 552podusage() {
376 echo 553 echo
554
377 if [ -e "$PERL_PREFIX/bin/perl" ]; then 555 if [ -e "$PERL_PREFIX/bin/perl" ]; then
378 "$PERL_PREFIX/bin/perl" -MPod::Usage -e \ 556 "$PERL_PREFIX/bin/perl" -MPod::Usage -e \
379 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \ 557 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \
380 2>/dev/null && exit 558 2>/dev/null && exit
381 fi 559 fi
560
382 # try whatever perl we can find 561 # try whatever perl we can find
383 perl -MPod::Usage -e \ 562 perl -MPod::Usage -e \
384 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \ 563 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \
385 2>/dev/null && exit 564 2>/dev/null && exit
386 565
387 fatal "displaying documentation requires a working perl - try '$0 install' first" 566 fatal "displaying documentation requires a working perl - try '$0 install' to build one in a safe location"
388} 567}
389 568
390usage() { 569usage() {
391 podusage 0 570 podusage 0
392} 571}
394catmkbundle() { 573catmkbundle() {
395 { 574 {
396 read dummy 575 read dummy
397 echo "#!$PERL_PREFIX/bin/perl" 576 echo "#!$PERL_PREFIX/bin/perl"
398 cat 577 cat
399 } <<'MKBUNDLE' 578 } <<'end_of_mkbundle'
400#CAT mkbundle 579#CAT mkbundle
401MKBUNDLE 580end_of_mkbundle
402} 581}
403 582
404bundle() { 583bundle() {
584 MKBUNDLE="${MKBUNDLE:=$PERL_PREFIX/bin/SP-mkbundle}"
405 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create" 585 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create"
406 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE" 586 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE"
407 CACHE="$STATICPERL/cache" 587 CACHE="$STATICPERL/cache"
408 mkdir -p "$CACHE" 588 mkdir -p "$CACHE"
409 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" --cache "$CACHE" "$@" 589 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" --cache "$CACHE" "$@"
417 command="${1#--}"; shift 597 command="${1#--}"; shift
418 case "$command" in 598 case "$command" in
419 version ) 599 version )
420 echo "staticperl version $VERSION" 600 echo "staticperl version $VERSION"
421 ;; 601 ;;
422 fetch | configure | build | install | clean | distclean) 602 fetch | configure | build | install | clean | realclean | distclean )
423 ( "$command" ) 603 ( "$command" ) || exit
604 ;;
605 import )
606 ( import "$1" ) || exit
607 shift
424 ;; 608 ;;
425 instsrc ) 609 instsrc )
426 ( instsrc "$@" ) 610 ( instsrc "$@" ) || exit
427 exit 611 exit
428 ;; 612 ;;
429 instcpan ) 613 instcpan )
430 ( instcpan "$@" ) 614 ( instcpan "$@" ) || exit
431 exit 615 exit
432 ;; 616 ;;
617 perl )
618 ( install ) || exit
619 exec "$PERL_PREFIX/bin/perl" "$@"
620 exit
621 ;;
433 cpan ) 622 cpan )
434 ( install ) 623 ( install ) || exit
624 PERL="$PERL_PREFIX/bin/perl"
625 export PERL
435 "$PERL_PREFIX/bin/cpan" "$@" 626 exec "$PERL_PREFIX/bin/cpan" "$@"
436 exit 627 exit
437 ;; 628 ;;
438 mkbundle ) 629 mkbundle )
439 ( install ) 630 ( install ) || exit
440 bundle "$@" 631 bundle "$@"
441 exit 632 exit
442 ;; 633 ;;
443 mkperl ) 634 mkperl )
444 ( install ) 635 ( install ) || exit
445 bundle --perl "$@" 636 bundle --perl "$@"
446 exit 637 exit
447 ;; 638 ;;
448 mkapp ) 639 mkapp )
449 ( install ) 640 ( install ) || exit
450 bundle --app "$@" 641 bundle --app "$@"
451 exit 642 exit
452 ;; 643 ;;
453 help ) 644 help )
454 podusage 2 645 podusage 2

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines